#
# Exercise 6.2
#
Af,E=AffineSpace(QQ,3)
Poly.<x,y,z>=PolynomialRing(QQ,3)
r=VarietyByEquations([x-1+2*y-6,-3*y+9-z+2],Af)
H=VarietyByEquations([2*x-y+z-1],Af)
f=OrthogonalSymmetry(H)
rprime=ImageOfVariety(f,r)
CartesianEquations(rprime,Poly)
#
# Exercise 6.3
#
Af,E=AffineSpace(AA,2)
u=E([1,-1]); v=E([1,1])
B=Frame(Af(0),[u,v])
s3=AA(sqrt(3))
A=matrix([[-s3/2,-1/2,1],[-1/2,s3/2,2],[0,0,1]])
P=ChangeOfFrameMatrix(B,CanonicalFrame(Af))
T=MatrixAsAffinity(P*A*P^(-1),Af)
IsEuclideanMotion(T)
#
# Exercise 6.4
#
Af,E=AffineSpace(AA,3)
s2=AA(sqrt(2)); s3=AA(sqrt(3))
A=(1/4)*matrix([[2+s3,-s2,-2+s3,4],[s2,2*s3,s2,0],[-2+s3,-s2,2+s3,4],[0,0,0,4]])
T=MatrixAsAffinity(A,Af)
IsEuclideanMotion(T)
#
# Exercise 6.5
#
Af,E=AffineSpace(QQ,3)
Poly.<x,y,z>=PolynomialRing(QQ,3)
L1=VarietyByEquations([x+y+z-2,x-y+z-1],Af)
L2=Variety(Af([0,3,4]),E.subspace([E([2,2,3]),E([1,2,2])]))
P=Af([2,1,3])
OrthogonalProjection(L1)(P)
OrthogonalProjection(L2)(P)
OrthogonalSymmetry(L2)(P)
#
# Exercise 6.6
#
Af,E=AffineSpace(QQ,3)
Poly.<x,y,z>=PolynomialRing(QQ,3)
L1=VarietyByEquations([x-y-z-1,y-2*z],Af)
L2=VarietyByEquations([x+y-1,z+2*y+1],Af)
P=Af([-1,1,3])
OrthogonalSymmetry(L1)(P)
OrthogonalSymmetry(L2)(P)
#
# Exercise 6.7
# 
Af,E=AffineSpace(QQ,2,metric=matrix([[4,1],[1,1]]))
Poly.<x,y>=PolynomialRing(QQ,2)
P=Af([2,3])
L=VarietyByEquations([x+y+1],Af)
OrthogonalSymmetry(L)(P)
#
# Exercise 6.9
#
Af,E=AffineSpace(AA,2,metric=matrix([[3,2],[2,2]]))
Poly.<x,y>=PolynomialRing(AA,2)
s3=AA(sqrt(3))
R=Frame(Af(0),[E([1/2,s3/2]),E([s3/2,-1/2])])
P=ChangeOfFrameMatrix(R,CanonicalFrame(Af))
f=MatrixAsAffinity(P^(-1)*matrix([[1,0,0],[0,-1,0],[0,0,1]])*P,Af)
EquationsOfAffinity(f,Poly)











   

