# Exercises in Chapter 1
#
# Exercise 9
#
A,E=AffineSpace(QQ,4)
Poly.<x,y,z,t>=PolynomialRing(QQ,4)
X1=VarietyByEquations([x+y-z-2*t,3*x-y+z+4*t-1,2*y-2*z-5*t+1/2],A)
X2=VarietyByEquations([-z+t-1,2*x+y+z-t,4*x+2*y+2*z+t-3],A)
X3=VarietyByEquations([2*x-y+t+1,-x+2*y+z-2*t-2],A)
X4=VarietyByEquations([3*x+z],A)
X5=VarietyByEquations([-x+2*y+z-2*t-2,3*x+z],A)
X6=VarietyByEquations([2*x-y+t+1,-x+2*y+z-2*t-2,3*x+z+t-4],A)
BasePoint(X1)
Direction(X1)
BasePoint(X2)
Direction(X2)
BasePoint(X3)
Direction(X3)
BasePoint(X4)
Direction(X4)
BasePoint(X5)
Direction(X5)
BasePoint(X6)
Direction(X6)
#
# Exercise 10
#
A,E=AffineSpace(QQ,3)
Poly.<x,y,z>=PolynomialRing(QQ,3)
X=Variety(A([2,-1,2]),E.subspace([[-1,0,1]]))
Y=Variety(A([0,-5,0]),E.subspace([E([1,1,2]),E([-1,0,3])]))
CartesianEquations(X,Poly)
CartesianEquations(Y,Poly)
#
# Exercise 11
#
A,E=AffineSpace(QQ,4)
Poly.<x,y,z,t>=PolynomialRing(QQ,4)
P=PointAsVariety(A([2,1,0,1]))
Q=PointAsVariety(A([1,1,1,2]))
R=PointAsVariety(A([3,-1,2,3]))
S=PointAsVariety(A([0,0,-2,-1]))
X1=AffineSum([P,Q])
X2=AffineSum([X1,R])
X3=AffineSum([X2,S])
CartesianEquations(X1,Poly)
CartesianEquations(X2,Poly)
CartesianEquations(X3,Poly)
#
# Exercise 12
#
A,E=AffineSpace(QQ,4)
Poly.<x,y,z,t>=PolynomialRing(QQ,4)
L=VarietyByEquations([-2*x+3*y+4*z+t-5],A)
M=VarietyByEquations([x-y+2*z-2*t-7,3*x+z+t-7,x-y+5*z+6*t,-2*x-y+z-3*t],A)
N=VarietyByEquations([-2*x+3*y+4*z+t-5,-x+4*y+z-5*t-8],A)
print "Dim(L)=", AffineDimension(L)
print "L: (x,y,z,t)= ", BasePoint(L), " +  <", Direction(L).basis(), ">"
print "Dim(M)=", AffineDimension(M)
print "M: (x,y,z,t)= ", BasePoint(M), " +  <", Direction(M).basis(), ">"
print "Dim(N)=", AffineDimension(N)
print "N: (x,y,z,t)= ", BasePoint(N), " +  <", Direction(N).basis(), ">"
Z=AffineSum([M,N])
Z
if Meet(L,M):
  a,X=Meet(L,M) 
  X 
else:
  print "L cap M is empty" 
if Meet(M,N):
  a,Y=Meet(M,N)
  Y
else:
  print "M cap N is empty" 
BasePoint(X)
#
# Exercise 15
#
A,E=AffineSpace(QQ,4)
Poly.<x,y,z,t>=PolynomialRing(QQ,4)
P=A([1,2,3,4])
Pi=VarietyByEquations([x-y+z+t-3,2*x+y-5*t-10],A)
F=Direction(Pi)
X=Variety(P,F)
X
CartesianEquations(X,Poly)
Y=Variety(P,E.subspace([E([2,1,1,0]),E([1,1,-2,1])]))
Y
CartesianEquations(Y,Poly)
#
# Exercise 16
#
A,E=AffineSpace(QQ,4)
Poly.<x,y,z,t>=PolynomialRing(QQ,4)
P=A([2,3,0,-4])
u=E([0,2,1,-5])
v=E([3,-1,1/2,0])
w=E([1,1,1,1])
L=Variety(P,E.subspace([u]))
X=Variety(P,E.subspace([u,v]))
Y=Variety(P,E.subspace([u,v,w]))
CartesianEquations(L,Poly)
CartesianEquations(X,Poly)
CartesianEquations(Y,Poly)
#
# Exercise 17
#
A,E=AffineSpace(QQ,4)
Poly.<x,y,z,t>=PolynomialRing(QQ,4)
r=VarietyByEquations([2*x-y+t+1,-x+2*y+z-2*t-2,3*x+z+t-4],A)
s=VarietyByEquations([x-y+t-3,x+2*y+z-2*t-2,x+z+t],A)
Fr=Direction(r)
Fs=Direction(s)
P=BasePoint(r)
X=Variety(P,Fr+Fs)
AffineDimension(X)==2
Parallel(X,s)
Contained(r,X)
BasePoint(X)
Direction(X)
CartesianEquations(X,Poly)
#
# Exercise 18
#
A,E=AffineSpace(QQ,4)
Poly.<x,y,z,t>=PolynomialRing(QQ,4)
H=VarietyByEquations([x+y+z+t],A)
L=Variety(A([1,1,1,1]),E.subspace([[2,-1,0,-1]]))
X=VarietyByEquations([2*x+y-z-2,4*x+t-5],A)
F=Direction(H)
P=BasePoint(L)
G=Direction(L)
T=Direction(X)
PI=Variety(P,(T.intersection(F))+G)
AffineDimension(PI)==2
Parallel(PI,H)
Contained(L,PI)
Y=Variety(BasePoint(X),Direction(PI))
AffineDimension(Y)
Parallel(Y,PI)
a,W=Meet(Y,X)
AffineDimension(W)
PI
CartesianEquations(PI,Poly)
#
# Exercise 19
#
A,E=AffineSpace(QQ,4)
Poly.<x,y,z,t>=PolynomialRing(QQ,4)
L=Variety(A([1,1,1,1]),E.subspace([E([2,-1,0,-1])]))
PI=AffineSum([PointAsVariety(A([0,0,-2,3])),L])
PI
CartesianEquations(PI,Poly)
F=Direction(PI)
P=A([0,1,0,1])
Q=A([0,0,-2,3])
u=Arrow(P,Q)
U,pi,lift=E.quotient_abstract(F+E.subspace([u])); G=lift(U)
QU=Variety(P,G+E.subspace([u]))
AffineDimension(QU)
Belongs(P,QU)
Meet(PI,QU)
a,Z=Meet(PI,QU)
EqualityOfVarieties(Z,PointAsVariety(Q))
#
# Exercise 21
#
var('a')
A,E=AffineSpace(SR,4)
L1=Variety(A([a,1,4,6]),E.subspace([E([3,-1,1,5]),E([2,-1,0,2])]))
L2=Variety(A([2,1,1,0]),E.subspace([E([1,0,1,3]),E([2,0,1,0])]))
F1=Direction(L1)
F2=Direction(L2)
P1=BasePoint(L1)
P2=BasePoint(L2)
u=Arrow(P1,P2)
# The condition is that u must be in F1+F2
u
F1+F2
# we see that u is in F1+F2 is and only if a=6
a=6
A,E=AffineSpace(QQ,4)
Poly.<x,y,z,t>=PolynomialRing(QQ,4)
L1=Variety(A([a,1,4,6]),E.subspace([E([3,-1,1,5]),E([2,-1,0,2])]))
L2=Variety(A([2,1,1,0]),E.subspace([E([1,0,1,3]),E([2,0,1,0])]))
Meet(L1,L2)
a,Z=Meet(L1,L2)
Z
AffineSum([L1,L2])
#
# Exercise 29
#
var('a')
A,E=AffineSpace(SR,4)
Poly.<x,y,z,t>=PolynomialRing(SR,4)
L1=VarietyByEquations([x+y-4,z+t-a],A)
L2=Variety(A([3,2,0,-1]),E.subspace([E([1,-2,2,1])]))
Parallel(L1,L2)
# since L2 and L2 are not parallel, L1+L2 minimum dimension is 3 
# this happens exactly when L1 and L2 meet in a single point.
S1=CartesianEquations(L1,Poly)
S2=CartesianEquations(L2,Poly)
# Hence, these two points must coincide:
VarietyByEquations([S1[0]]+S2,A)
VarietyByEquations([S1[1]]+S2,A)
# this is equivalent to a=2
# let's check it
a=2
A,E=AffineSpace(QQ,4)
L1=VarietyByEquations([x+y-4,z+t-a],A)
L2=Variety(A([3,2,0,-1]),E.subspace([E([1,-2,2,1])]))
AffineDimension(AffineSum([L1,L2]))
#
# Exercise 34
#
A,E=AffineSpace(QQ,3)
e1=E([1,0,0]); e2=E([0,1,0]); e3=E([0,0,1])
R1=Frame(A([1,1,1]),[e3-e1,e1+e3,e1+e2])
R2=Frame(A([0,1,1]),[e1,2*e2-e3,3*e1-e3])
ChangeOfFrameMatrix(R1,R2)
#
# Exercise 35
#
A,E=AffineSpace(QQ,3)
Ref=Frame(A([1,1,1]),[E([1,1,1]),E([0,1,0]),E([2,1,0])])
P=A([0,0,0]); Q=A([1,1,1])
AffineCoordinates(P,Ref)
AffineCoordinates(Q,Ref)
M=FrameAsMatrix(Ref)
M.transpose().eigenspaces_left()
# There is no such a point with equal coordinates
M
#
# Exercise 36
#
A,E=AffineSpace(QQ,3)
C=CanonicalFrame(A)
Ref=Frame(A([-1,0,0]),[E([1,1,0]),E([0,-1,0]),E([0,0,-1])])
P=A([1,2,-1])
AffineCoordinates(P,Ref)
Poly.<x,y,z>=PolynomialRing(QQ,3)
Z=ChangeOfFrameVariety(VarietyByEquations([2*x-y+z+2],A),Ref)
CartesianEquations(Z,Poly)
T=ChangeOfFrameVariety(VarietyByEquations([2*x+y,x-2*y+z-1],A),Ref)
CartesianEquations(T,Poly)
#
# Exercise 45
# Proof of Desargues Theorem
#
var('a,b,c,d,l')
A,E=AffineSpace(SR,2)
A1=PointAsVariety(A([0,1]))
A2=PointAsVariety(A([0,b]))
B1=PointAsVariety(A([1,0]))
B2=PointAsVariety(A([a,0]))
C1=PointAsVariety(A([c,d]))
C2=PointAsVariety(A([l*c,l*d]))
xx,P=Meet(AffineSum([B1,C1]),AffineSum([B2,C2]))
yy,Q=Meet(AffineSum([A1,C1]),AffineSum([A2,C2]))
zz,R=Meet(AffineSum([A1,B1]),AffineSum([A2,B2]))
AffineDimension(AffineSum([P,Q,R]))
#
# Exercise 46
# Proof of Pappus Theorem
#
var('a,b,c,d,l')
A,E=AffineSpace(SR,2)
A1=PointAsVariety(A([0,0]))
B1=PointAsVariety(A([0,a]))
C1=PointAsVariety(A([0,1]))
A2=PointAsVariety(A([b,c]))
B2=PointAsVariety(A([1,0]))
C2=PointAsVariety(A([l*(b-1)+1,l*c]))
xx,P=Meet(AffineSum([A1,B2]),AffineSum([A2,B1]))
yy,Q=Meet(AffineSum([A1,C2]),AffineSum([A2,C1]))
zz,R=Meet(AffineSum([B1,C2]),AffineSum([B2,C1]))
AffineDimension(AffineSum([P,Q,R]))
#




























