#
# Exercise 7.5
#
Af,E=AffineSpace(AA,2)
u=3*pi/2
M=matrix([[AA(cos(u)),-AA(sin(u)),1],[AA(sin(u)),AA(cos(u)),1],[0,0,1]])
f=MatrixAsAffinity(M,Af)
EuclideanNormalFormOfAffinity(f)
#
# 7.6
#
Af,E=AffineSpace(AA,2)
Poly.<x,y>=PolynomialRing(AA,2)
R=RotationMatrix(Af([2,1]),pi/6)
Symbolize(R,size='matrix')
L=VarietyByEquations([x+2*y-2],Af)
S=AffinityAsMatrix(OrthogonalSymmetry(L))
#
# 7.9
#
Af,E=AffineSpace(AA,2)
Poly.<x,y>=PolynomialRing(AA,2)
s3=AA(sqrt(3))
P=Af(0); u=(1/2)*E([1,s3]); v=(1/2)*E([s3,-1])
R=Frame(P,[u,v])
f=AffinityByEquations([x,-y],Af)
h=MatrixAsAffinity(FrameAsMatrix(R),Af)
g=Conjugate(f,h)
Symbolize(AffinityAsMatrix(g),size='matrix')
#
# 7.16
#
Af,E=AffineSpace(AA,3)
Poly.<x,y,z>=PolynomialRing(AA,3)
T=AffinityByEquations([x/3-2*y/3-2*z/3+1,-2*x/3+y/3-2*z/3,-2*x/3-2*y/3+z/3-2],Af)
FixedPoints(T)
SparseInvariantLines(T)
SpecialInvariantLines(T)
GlideVector(T)
M,N=EuclideanNormalFormOfAffinity(T,transformation=True)
Symbolize(M,size='matrix')
Symbolize(N,size='matrix')
#
# 7.17
#
Af,E=AffineSpace(QQ,3)
f=MatrixAsAffinity(matrix([[0,0,1,2],[1,0,0,-3],[0,1,0,1],[0,0,0,1]]),Af)
v=E([2,3,-1])
T=AffineTranslation(v)
g=CompositionOfAffinities(f,T)
Symbolize(EuclideanNormalFormOfAffinity(g),size='matrix')
#
# 7.20
#
Af,E=AffineSpace(AA,2)
s3=AA(sqrt(3)); s5=AA(sqrt(5))
T=AffineTranslation(E([1,0]))
f=MatrixAsAffinity(matrix([[s3/2,-1/2,0],[1/2,s3/2,0],[0,0,1]]),Af)
g=MatrixAsAffinity(matrix([[1/2,-s3/2,0],[s3/2,1/2,1],[0,0,1]]),Af)
h=MatrixAsAffinity(matrix([[0,-1,-1],[1,0,0],[0,0,1]]),Af)
i=MatrixAsAffinity(matrix([[(1+s5)/4,-AA(sqrt((5-s5)/8)),0],[AA(sqrt((5-s5)/8)),(1+s5)/4,0],[0,0,1]]),Af)
j=MatrixAsAffinity(matrix([[(-1+s5)/4,-AA(sqrt((5+s5)/8)),2],[AA(sqrt((5+s5)/8)),(-1+s5)/4,0],[0,0,1]]),Af)
k=MatrixAsAffinity(matrix([[(1-s5)/4,-AA(sqrt((5+s5)/8)),0],[AA(sqrt((5+s5)/8)),(1-s5)/4,0],[0,0,1]]),Af)
M,N=EuclideanNormalFormOfAffinity(f,transformation=True)
Symbolize(M,size='matrix')
Symbolize(N,size='matrix')
M,N=EuclideanNormalFormOfAffinity(g,transformation=True)
Symbolize(M,size='matrix')
Symbolize(N,size='matrix')
M,N=EuclideanNormalFormOfAffinity(h,transformation=True)
Symbolize(M,size='matrix')
Symbolize(N,size='matrix')
M,N=EuclideanNormalFormOfAffinity(i,transformation=True)
Symbolize(M,size='matrix')
Symbolize(N,size='matrix')
M,N=EuclideanNormalFormOfAffinity(j,transformation=True)
Symbolize(M,size='matrix')
Symbolize(N,size='matrix')
M,N=EuclideanNormalFormOfAffinity(k,transformation=True)
Symbolize(M,size='matrix')
Symbolize(N,size='matrix')
GlideVector(f)
GlideVector(g)
GlideVector(h)
GlideVector(i)
GlideVector(j)
GlideVector(k)
FixedPoints(f)
FixedPoints(g)
FixedPoints(h)
FixedPoints(i)
FixedPoints(j)
FixedPoints(k)
SparseInvariantLines(f)
SparseInvariantLines(g)
SparseInvariantLines(h)
SparseInvariantLines(i)
SparseInvariantLines(j)
SparseInvariantLines(k)
SpecialInvariantLines(f)
SpecialInvariantLines(g)
SpecialInvariantLines(h)
SpecialInvariantLines(i)
SpecialInvariantLines(j)
SpecialInvariantLines(k)
IsRotation(AffinityAsMatrix(f),params=True)
IsRotation(AffinityAsMatrix(g),params=True)
IsRotation(AffinityAsMatrix(h),params=True)
IsRotation(AffinityAsMatrix(i),params=True)
IsRotation(AffinityAsMatrix(j),params=True)
IsRotation(AffinityAsMatrix(k),params=True)
#
# Example 7.4
#
Af,E=AffineSpace(AA,3)
s3=AA(sqrt(3)); s2=AA(sqrt(2))
M=(1/16)*matrix([[s3+2,11*s2,s3-2,16*s2],[-7*s2-2*s2*s3,2*s3,-7*s2+2*s2*s3,-32],[-3*s3+10,-s2,-3*s3-10,16*s2],[0,0,0,16]])
f=MatrixAsAffinity(M,Af)
AffineDimension(FixedPoints(f))
Symbolize(FixedPoints(f)[0],size='list')
SparseInvariantLines(f)
SIL=SparseInvariantLines(f)
Symbolize(SIL[0][0],size='list')
Symbolize(SIL[0][1],size='list')
SpecialInvariantLines(f)
GlideVector(f)
N,P=EuclideanNormalFormOfAffinity(f,transformation=True)
Symbolize(N,size='matrix')
IsRotation(M.submatrix(1,1,3,3),params=True)
Symbolize(P,size='matrix')
N==P^(-1)*AffinityAsMatrix(f)*P 
#
# Example 7.5
#
Af,E=AffineSpace(AA,3)
s2=AA(sqrt(2))
M=matrix([[(s2+2)/4,(-s2+2)/4,1/2,0],[(-s2+2)/4,(s2+2)/4,-1/2,4],[1/2,-1/2,-1/s2,2*s2],[0,0,0,1]])
f=MatrixAsAffinity(M,Af)
IsEuclideanMotion(f)
FixedPoints(f)
SpecialInvariantLines(f)
Symbolize(EuclideanNormalFormOfAffinity(f),size='matrix')
Symbolize(GlideVector(f),size='list')
N,P=EuclideanNormalFormOfAffinity(f,transformation=True)
Symbolize(N,size='matrix')
view(Symbolize(P,size='matrix'))
N==P^(-1)*AffinityAsMatrix(f)*P 
boo,Q=IsEuclideanMotion(f,orthobase=True)
view(Symbolize(Q,size='matrix'))
#
# 7.24
#
Af,E=AffineSpace(AA,2)
Poly.<x,y>=PolynomialRing(AA,2)
f=AffinityByEquations([y+1,x+1],Af)
g=AffinityByEquations([(-4/5)*x+(3/5)*y+1,(3/5)*x+(4/5)*y+3],Af)
FixedPoints(f)
FixedPoints(g)
IsSimilar(f,g)
boo,h=IsSimilar(f,g,transformation=True)
AffinityAsMatrix(h)
IsEuclideanMotion(h)
IsEuclideanSimilar(f,g)
Symbolize(EuclideanNormalFormOfAffinity(f),size='matrix')
Symbolize(EuclideanNormalFormOfAffinity(g),size='matrix')

